# std::char_traits<CharT>::not_eof

From cppreference.com
< cpp‎ | string‎ | char traits

static int_type not_eof( int_type e ); |  | (until C++11)
static constexpr int_type not_eof( int_type e ) noexcept; |  | (since C++11)

Checks whether `e` is not equivalent to eof value.

Formally

- if X::eq_int_type(e, X::eof()) is `false`, returns `e`
- otherwise, returns a value f such that X::eq_int_type(f, X::eof()) is `false`

### Parameters

e | - | value to analyze

### Return value

`e` if `e` and eof value are not equivalent, returns some other non-eof value otherwise.

### Complexity

Constant.

### See also

eof [static] | returns an eof value (public static member function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/string/char_traits/not_eof&oldid=94894"